//All train scripting (c) 2006 Kerm Martian / Christopher Mitchell
//All rights reserved.  This script can only be used/redistributed with TBM or derivatives.
//It may not be used in any other mod without express written permission from the author.
//http://www.cemetech.net

function addTrain(%t,%set) {
	if (!$trainstore[0,0] || $trainstore[0,0]==0)
	{
		$trainstore[0,0] = 1;
		$trainstore[1,0] = 1;
		$trainstore[1,1] = %set;
		$trainstore[1,2] = %t;
		echo("Trainstore array created!");
	} else {
		%found = 0;
		for(%x=1;%x<=$trainstore[0,0];%x++)
		{
			if ($trainstore[%x,1] == %set) { %found = %x; }
		}
		if (%found == 0)
		{
			$trainstore[0,0]++;
			$trainstore[$trainstore[0,0],0] = 1;
			$trainstore[$trainstore[0,0],1] = %set;
			$trainstore[$trainstore[0,0],2] = %t;
			echo("New train started!");
		} else {
			$trainstore[%found,0]++;
			$trainstore[%found,$trainstore[%found,0]+1] = %t;
			echo("Car #" @ $trainstore[%found,0] @ " add to train!");
		}
	}	
}
function setDriveable(%t,%set) {
	echo("Schedule begun for " @%t);
	schedule(1000,0,setAllVelocities,%t,%set);
	$trainspeedreport = 0;
}
function setAllVelocities(%t,%set) {
	%speed = vectorscale(%t.getVelocity(),120);
	%velx = getWord(%speed,0);
	%vely = getWord(%speed,1);
	%velz = getWord(%speed,2);
	%absvel = mSqrt((%velx*%velx)+(%vely*%vely)+(%velz*%velz));
	//echo(">>>SetVel: " @ %absvel @ "for" @ %set);
	%found = 0;
	$trainspeedreport++;
	for(%x=1;%x<=$trainstore[0,0];%x++)
	{
		if ($trainstore[%x,1] == %set) { %found = %x; }
	}
	if (!%found) { echo("Error finding specified train!!"); }
	for(%x=2;%x<=$trainstore[%found,0]+1;%x++) 	{
		if (isobject($trainstore[%found,%x]) && $trainstore[%found,%x] != 0) {
			%which = $trainstore[%found,%x];
			if (%which != %t )
			{
				%thisz = %which.getVelocity();
				%thisz = getWord(%thisz,2);
				%thisxy= vectorscale(%which.getforwardvector(),%absvel);
				%thisx = getWord(%thisxy,0);
				%thisy = getWord(%thisxy,1);
				%which.setVelocity(%thisx @ " " @%thisy@ " " @%thisz);
				//echo(vectorscale(%which.getforwardvector(),%absvel));
				if ($trainspeedreport == (1000/25)*5)
				{
					messageall('msg',"This train is going " @ %thisx @ " " @%thisy@ " " @%thisz @ " m/s.");
				}
			}
			//stuff
		} else {
			$trainstore[%found,%x] = 0;
		}
	}
	if ($trainspeedreport == (1000/25)*5)
	{
		$trainspeedreport = 0;
	}
	if (isobject(%t))
	{
		schedule(25,0,setAllVelocities,%t,%set);
	}
}

exec("./car.cs");
exec("./specialvehicles.cs");
exec("./tbm_copter.cs");
exec("./legocart.cs");
exec("./kart2.cs");
exec("./tbmtrain.cs");
exec("./monorail.cs");
exec("./diesel.cs");
exec("./tbmtank.cs");
exec("./dwing.cs");
exec("./psiwing.cs");
exec("./sigmafighter.cs");
exec("./cylinder.cs");